<div class="row">
  <div class="col-sm-12"
       *ngFor="let item of timeline | keyvalue ">
    <div class="btn btn-block btn-outline-info tile tile-announcement" role="button">
      <div class="tile" style="font-weight: bolder;">{{item.key | date:'dd.MM.y HH:mm'}}</div>
      <div *ngFor="let teItem of item.value" (click)="openModal(show,teItem)">
        <div class="btn btn-block btn-dark" role="button" style="width: auto; position: relative;">
          <div style="font-weight: bold;">
            {{teItem.title}}
          </div>
          <div>
            <div>
              {{teItem.additionalInformation}}
            </div>
            <div style="font-weight: lighter;">
              {{teItem.duration}}
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div class="col-sm-12">
    <button class="btn btn-block btn-outline-info tile tile-announcement"
            (click)="openAddModal(add)">
      <fa-icon [icon]="faPencilAlt"></fa-icon>
      <span class="desc">New Timeline Entry</span>
    </button>
  </div>
</div>
<ng-template #add let-modal>
  <form [formGroup]="timelineEntryForm" (ngSubmit)="saveTimelineEntry(modal)">
    <div class="modal-header">
      <h4 class="modal-title">Add a new Timeline Entry</h4>
      <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
        <span aria-hidden="true">x</span>
      </button>
    </div>
    <div class="modal-body">
      <div class="form-group">
        <label for="inputHeadline">Title</label>
        <input type="text" formControlName="title" class="form-control" id="inputHeadline"
               placeholder="A click bait like headline!"/>
      </div>
      <div class="form-group">
        <label for="startTime">Start Time</label>
        <input class="form-control" id="startTime" formControlName="startTime"/>
      </div>
      <div class="form-group">
        <label for="duration">Duration</label>
        <input class="form-control" id="duration" formControlName="duration"/>
      </div>
      <div class="form-group">
        <label for="additionalInformation">Additional Information</label>
        <textarea class="form-control" id="additionalInformation" formControlName="additionalInformation"
                  rows="5"></textarea>
      </div>
      <ngb-alert *ngIf="uploadingMessage" type="warning" (close)="uploadingMessage = null">{{uploadingMessage}}
      </ngb-alert>
    </div>
    <div class="modal-footer">
      <button type="submit" [disabled]="!timelineEntryForm.valid" class="btn btn-primary">Save</button>
    </div>
  </form>
</ng-template>
<ng-template #show let-modal>
  <form [formGroup]="timelineEntryForm" (ngSubmit)="updateTimelineEntry(modal)">
    <div class="modal-header">
      <h4 class="modal-title">
        {{timelineEntryForm.get('title').value}}
        <br/>
        <small>
          {{timelineEntryForm.get('startTime').value | date:'medium'}}
        </small>
        <br/>
        <button type="button" class="btn btn-danger" (click)="deleteElement(timelineEntryForm.get('id').value, modal)">
          Delete
        </button>
      </h4>
      <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
    <div class="modal-body">
      <div class="form-group">
        <label>Id</label><br/>
        {{timelineEntryForm.get('id').value}}
        <!--<input type="text" formControlName="id" class="form-control" id="idEdit" disabled>-->
      </div>
      <div class="form-group">
        <label for="startTimeEdit">Start Time</label>
        <input type="text" formControlName="startTime" class="form-control" id="startTimeEdit">
      </div>
      <div class="form-group">
        <label for="titleEdit">Title</label>
        <input type="text" formControlName="title" class="form-control" id="titleEdit"
               placeholder="New Title">
      </div>
      <div class="form-group">
        <label for="durationEdit">Duration</label>
        <input type="text" formControlName="duration" class="form-control" id="durationEdit"
               placeholder="New Duration">
      </div>
      <div class="form-group">
        <label for="inputTextEdit">Additional Information</label>
        <textarea class="form-control" id="inputTextEdit" formControlName="additionalInformation" rows="5">
        </textarea>
      </div>
    </div>
    <div class="modal-footer" style="justify-content: flex-start">
      <button type="submit" [disabled]="!timelineEntryForm.valid" class="btn btn-primary">Save</button>
    </div>
  </form>
</ng-template>
